// services/network/public/mojom/trust_token_access_observer.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/network/public/mojom/trust_token_access_observer.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/network/public/mojom/trust_token_access_observer.mojom-params-data.h"
namespace network {
namespace mojom {

namespace internal {
// static
bool TrustTokenAccessDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const TrustTokenAccessDetails_Data* object = static_cast<const TrustTokenAccessDetails_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case TrustTokenAccessDetails_Tag::kIssuance: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_issuance, 1, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_issuance, validation_context))
        return false;
      return true;
    }
    case TrustTokenAccessDetails_Tag::kRedemption: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_redemption, 2, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_redemption, validation_context))
        return false;
      return true;
    }
    case TrustTokenAccessDetails_Tag::kSigning: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_signing, 3, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_signing, validation_context))
        return false;
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in TrustTokenAccessDetails");
      return false;
    }
  }
}


// static
bool TrustTokenIssuanceDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TrustTokenIssuanceDetails_Data* object =
      static_cast<const TrustTokenIssuanceDetails_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->origin, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->origin, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->issuer, validation_context))
    return false;

  return true;
}

TrustTokenIssuanceDetails_Data::TrustTokenIssuanceDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TrustTokenRedemptionDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TrustTokenRedemptionDetails_Data* object =
      static_cast<const TrustTokenRedemptionDetails_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->origin, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->origin, validation_context))
    return false;

  if (!mojo::internal::ValidateStruct(object->issuer, validation_context))
    return false;

  return true;
}

TrustTokenRedemptionDetails_Data::TrustTokenRedemptionDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TrustTokenSigningDetails_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TrustTokenSigningDetails_Data* object =
      static_cast<const TrustTokenSigningDetails_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->origin, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->origin, validation_context))
    return false;

  return true;
}

TrustTokenSigningDetails_Data::TrustTokenSigningDetails_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TrustTokenAccessObserver_OnTrustTokensAccessed_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TrustTokenAccessObserver_OnTrustTokensAccessed_Params_Data* object =
      static_cast<const TrustTokenAccessObserver_OnTrustTokensAccessed_Params_Data*>(data);

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->details, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->details, validation_context))
    return false;

  return true;
}

TrustTokenAccessObserver_OnTrustTokensAccessed_Params_Data::TrustTokenAccessObserver_OnTrustTokensAccessed_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool TrustTokenAccessObserver_Clone_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const TrustTokenAccessObserver_Clone_Params_Data* object =
      static_cast<const TrustTokenAccessObserver_Clone_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->listener, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->listener,
                                                 validation_context)) {
    return false;
  }

  return true;
}

TrustTokenAccessObserver_Clone_Params_Data::TrustTokenAccessObserver_Clone_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace network