// services/webnn/public/mojom/webnn_graph.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/webnn/public/mojom/webnn_graph.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/webnn/public/mojom/webnn_graph.mojom-params-data.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-shared-message-ids.h"

#include "services/webnn/public/mojom/webnn_graph.mojom-import-headers.h"
#include "services/webnn/public/mojom/webnn_graph.mojom-test-utils.h"


namespace webnn::mojom {
Operand::Operand()
    : kind(),
      data_type(),
      dimensions(),
      name() {}

Operand::Operand(
    Operand::Kind kind_in,
    Operand::DataType data_type_in,
    std::vector<uint32_t> dimensions_in,
    const std::optional<std::string>& name_in)
    : kind(std::move(kind_in)),
      data_type(std::move(data_type_in)),
      dimensions(std::move(dimensions_in)),
      name(std::move(name_in)) {}

Operand::~Operand() = default;

void Operand::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Operand::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "data_type"), this->data_type,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Operand::DataType>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "dimensions"), this->dimensions,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "name"), this->name,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::optional<std::string>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Operand::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ArgMinMax::ArgMinMax()
    : kind(),
      input_operand_id(),
      output_operand_id(),
      axes(),
      keep_dimensions(false),
      select_last_index(false) {}

ArgMinMax::ArgMinMax(
    ArgMinMax::Kind kind_in,
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::vector<uint32_t> axes_in,
    bool keep_dimensions_in,
    bool select_last_index_in)
    : kind(std::move(kind_in)),
      input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      axes(std::move(axes_in)),
      keep_dimensions(std::move(keep_dimensions_in)),
      select_last_index(std::move(select_last_index_in)) {}

ArgMinMax::~ArgMinMax() = default;

void ArgMinMax::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ArgMinMax::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axes"), this->axes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "keep_dimensions"), this->keep_dimensions,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "select_last_index"), this->select_last_index,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ArgMinMax::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
BatchNormalization::BatchNormalization()
    : input_operand_id(),
      mean_operand_id(),
      variance_operand_id(),
      output_operand_id(),
      scale_operand_id(),
      bias_operand_id(),
      axis(1U),
      epsilon(1e-5f),
      activation() {}

BatchNormalization::BatchNormalization(
    uint64_t input_operand_id_in,
    uint64_t mean_operand_id_in,
    uint64_t variance_operand_id_in,
    uint64_t output_operand_id_in,
    std::optional<uint64_t> scale_operand_id_in,
    std::optional<uint64_t> bias_operand_id_in,
    uint32_t axis_in,
    float epsilon_in,
    ActivationPtr activation_in)
    : input_operand_id(std::move(input_operand_id_in)),
      mean_operand_id(std::move(mean_operand_id_in)),
      variance_operand_id(std::move(variance_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      scale_operand_id(std::move(scale_operand_id_in)),
      bias_operand_id(std::move(bias_operand_id_in)),
      axis(std::move(axis_in)),
      epsilon(std::move(epsilon_in)),
      activation(std::move(activation_in)) {}

BatchNormalization::~BatchNormalization() = default;

void BatchNormalization::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "mean_operand_id"), this->mean_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "variance_operand_id"), this->variance_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "scale_operand_id"), this->scale_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "bias_operand_id"), this->bias_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axis"), this->axis,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "epsilon"), this->epsilon,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "activation"), this->activation,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ActivationPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool BatchNormalization::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Clamp::Clamp()
    : input_operand_id(),
      output_operand_id(),
      min_value(),
      max_value() {}

Clamp::Clamp(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float min_value_in,
    float max_value_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      min_value(std::move(min_value_in)),
      max_value(std::move(max_value_in)) {}

Clamp::~Clamp() = default;
size_t Clamp::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->min_value);
  seed = mojo::internal::Hash(seed, this->max_value);
  return seed;
}

void Clamp::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "min_value"), this->min_value,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "max_value"), this->max_value,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Clamp::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Concat::Concat()
    : input_operand_ids(),
      output_operand_id(),
      axis() {}

Concat::Concat(
    std::vector<uint64_t> input_operand_ids_in,
    uint64_t output_operand_id_in,
    uint32_t axis_in)
    : input_operand_ids(std::move(input_operand_ids_in)),
      output_operand_id(std::move(output_operand_id_in)),
      axis(std::move(axis_in)) {}

Concat::~Concat() = default;

void Concat::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_ids"), this->input_operand_ids,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint64_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axis"), this->axis,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Concat::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Size2d::Size2d()
    : height(),
      width() {}

Size2d::Size2d(
    uint32_t height_in,
    uint32_t width_in)
    : height(std::move(height_in)),
      width(std::move(width_in)) {}

Size2d::~Size2d() = default;
size_t Size2d::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->height);
  seed = mojo::internal::Hash(seed, this->width);
  return seed;
}

void Size2d::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "height"), this->height,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "width"), this->width,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Size2d::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Padding2d::Padding2d()
    : beginning(),
      ending() {}

Padding2d::Padding2d(
    Size2dPtr beginning_in,
    Size2dPtr ending_in)
    : beginning(std::move(beginning_in)),
      ending(std::move(ending_in)) {}

Padding2d::~Padding2d() = default;
size_t Padding2d::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->beginning);
  seed = mojo::internal::Hash(seed, this->ending);
  return seed;
}

void Padding2d::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "beginning"), this->beginning,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "ending"), this->ending,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Padding2d::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Conv2d::Conv2d()
    : type(),
      input_operand_id(),
      filter_operand_id(),
      output_operand_id(),
      padding(),
      strides(),
      dilations(),
      groups(1U),
      input_layout(),
      bias_operand_id(),
      activation() {}

Conv2d::Conv2d(
    Conv2d::Type type_in,
    uint64_t input_operand_id_in,
    uint64_t filter_operand_id_in,
    uint64_t output_operand_id_in,
    Padding2dPtr padding_in,
    Size2dPtr strides_in,
    Size2dPtr dilations_in,
    uint32_t groups_in,
    InputOperandLayout input_layout_in,
    std::optional<uint64_t> bias_operand_id_in,
    ActivationPtr activation_in)
    : type(std::move(type_in)),
      input_operand_id(std::move(input_operand_id_in)),
      filter_operand_id(std::move(filter_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      padding(std::move(padding_in)),
      strides(std::move(strides_in)),
      dilations(std::move(dilations_in)),
      groups(std::move(groups_in)),
      input_layout(std::move(input_layout_in)),
      bias_operand_id(std::move(bias_operand_id_in)),
      activation(std::move(activation_in)) {}

Conv2d::~Conv2d() = default;

void Conv2d::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "type"), this->type,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Conv2d::Type>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "filter_operand_id"), this->filter_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "padding"), this->padding,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Padding2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "strides"), this->strides,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "dilations"), this->dilations,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "groups"), this->groups,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_layout"), this->input_layout,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type InputOperandLayout>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "bias_operand_id"), this->bias_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "activation"), this->activation,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ActivationPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Conv2d::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ElementWiseBinary::ElementWiseBinary()
    : kind(),
      lhs_operand(),
      rhs_operand(),
      output_operand() {}

ElementWiseBinary::ElementWiseBinary(
    ElementWiseBinary::Kind kind_in,
    uint64_t lhs_operand_in,
    uint64_t rhs_operand_in,
    uint64_t output_operand_in)
    : kind(std::move(kind_in)),
      lhs_operand(std::move(lhs_operand_in)),
      rhs_operand(std::move(rhs_operand_in)),
      output_operand(std::move(output_operand_in)) {}

ElementWiseBinary::~ElementWiseBinary() = default;
size_t ElementWiseBinary::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->kind);
  seed = mojo::internal::Hash(seed, this->lhs_operand);
  seed = mojo::internal::Hash(seed, this->rhs_operand);
  seed = mojo::internal::Hash(seed, this->output_operand);
  return seed;
}

void ElementWiseBinary::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ElementWiseBinary::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "lhs_operand"), this->lhs_operand,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "rhs_operand"), this->rhs_operand,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand"), this->output_operand,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ElementWiseBinary::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ElementWiseUnary::ElementWiseUnary()
    : kind(),
      input_operand_id(),
      output_operand_id() {}

ElementWiseUnary::ElementWiseUnary(
    ElementWiseUnary::Kind kind_in,
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : kind(std::move(kind_in)),
      input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

ElementWiseUnary::~ElementWiseUnary() = default;
size_t ElementWiseUnary::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->kind);
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void ElementWiseUnary::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ElementWiseUnary::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ElementWiseUnary::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Expand::Expand()
    : input_operand_id(),
      output_operand_id() {}

Expand::Expand(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Expand::~Expand() = default;
size_t Expand::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Expand::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Expand::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ConstantPadding::ConstantPadding()
    : value(0) {}

ConstantPadding::ConstantPadding(
    float value_in)
    : value(std::move(value_in)) {}

ConstantPadding::~ConstantPadding() = default;
size_t ConstantPadding::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->value);
  return seed;
}

void ConstantPadding::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "value"), this->value,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ConstantPadding::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
EdgePadding::EdgePadding() {}

EdgePadding::~EdgePadding() = default;
size_t EdgePadding::Hash(size_t seed) const {
  return seed;
}

void EdgePadding::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
}

bool EdgePadding::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
ReflectionPadding::ReflectionPadding() {}

ReflectionPadding::~ReflectionPadding() = default;
size_t ReflectionPadding::Hash(size_t seed) const {
  return seed;
}

void ReflectionPadding::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
}

bool ReflectionPadding::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
SymmetricPadding::SymmetricPadding() {}

SymmetricPadding::~SymmetricPadding() = default;
size_t SymmetricPadding::Hash(size_t seed) const {
  return seed;
}

void SymmetricPadding::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
}

bool SymmetricPadding::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
InstanceNormalization::InstanceNormalization()
    : input_operand_id(),
      output_operand_id(),
      scale_operand_id(),
      bias_operand_id(),
      epsilon(1e-5f),
      layout() {}

InstanceNormalization::InstanceNormalization(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::optional<uint64_t> scale_operand_id_in,
    std::optional<uint64_t> bias_operand_id_in,
    float epsilon_in,
    InputOperandLayout layout_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      scale_operand_id(std::move(scale_operand_id_in)),
      bias_operand_id(std::move(bias_operand_id_in)),
      epsilon(std::move(epsilon_in)),
      layout(std::move(layout_in)) {}

InstanceNormalization::~InstanceNormalization() = default;

void InstanceNormalization::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "scale_operand_id"), this->scale_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "bias_operand_id"), this->bias_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "epsilon"), this->epsilon,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "layout"), this->layout,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type InputOperandLayout>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool InstanceNormalization::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Matmul::Matmul()
    : a_operand_id(),
      b_operand_id(),
      output_operand_id() {}

Matmul::Matmul(
    uint64_t a_operand_id_in,
    uint64_t b_operand_id_in,
    uint64_t output_operand_id_in)
    : a_operand_id(std::move(a_operand_id_in)),
      b_operand_id(std::move(b_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Matmul::~Matmul() = default;
size_t Matmul::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->a_operand_id);
  seed = mojo::internal::Hash(seed, this->b_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Matmul::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "a_operand_id"), this->a_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "b_operand_id"), this->b_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Matmul::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Pad::Pad()
    : input_operand_id(),
      output_operand_id(),
      beginning_padding(),
      ending_padding(),
      mode() {}

Pad::Pad(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::vector<uint32_t> beginning_padding_in,
    std::vector<uint32_t> ending_padding_in,
    PaddingModePtr mode_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      beginning_padding(std::move(beginning_padding_in)),
      ending_padding(std::move(ending_padding_in)),
      mode(std::move(mode_in)) {}

Pad::~Pad() = default;

void Pad::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "beginning_padding"), this->beginning_padding,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "ending_padding"), this->ending_padding,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "mode"), this->mode,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type PaddingModePtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Pad::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Reduce::Reduce()
    : kind(),
      input_operand_id(),
      output_operand_id(),
      axes(),
      keep_dimensions(false) {}

Reduce::Reduce(
    Reduce::Kind kind_in,
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::vector<uint32_t> axes_in,
    bool keep_dimensions_in)
    : kind(std::move(kind_in)),
      input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      axes(std::move(axes_in)),
      keep_dimensions(std::move(keep_dimensions_in)) {}

Reduce::~Reduce() = default;

void Reduce::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Reduce::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axes"), this->axes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "keep_dimensions"), this->keep_dimensions,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Reduce::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Pool2d::Pool2d()
    : kind(),
      input_operand_id(),
      output_operand_id(),
      window_dimensions(),
      padding(),
      strides(),
      dilations(),
      layout() {}

Pool2d::Pool2d(
    Pool2d::Kind kind_in,
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    Size2dPtr window_dimensions_in,
    Padding2dPtr padding_in,
    Size2dPtr strides_in,
    Size2dPtr dilations_in,
    InputOperandLayout layout_in)
    : kind(std::move(kind_in)),
      input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      window_dimensions(std::move(window_dimensions_in)),
      padding(std::move(padding_in)),
      strides(std::move(strides_in)),
      dilations(std::move(dilations_in)),
      layout(std::move(layout_in)) {}

Pool2d::~Pool2d() = default;
size_t Pool2d::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->kind);
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->window_dimensions);
  seed = mojo::internal::Hash(seed, this->padding);
  seed = mojo::internal::Hash(seed, this->strides);
  seed = mojo::internal::Hash(seed, this->dilations);
  seed = mojo::internal::Hash(seed, this->layout);
  return seed;
}

void Pool2d::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "kind"), this->kind,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Pool2d::Kind>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "window_dimensions"), this->window_dimensions,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "padding"), this->padding,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Padding2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "strides"), this->strides,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "dilations"), this->dilations,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Size2dPtr>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "layout"), this->layout,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type InputOperandLayout>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Pool2d::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
StartAndSize::StartAndSize()
    : start(),
      size() {}

StartAndSize::StartAndSize(
    uint32_t start_in,
    uint32_t size_in)
    : start(std::move(start_in)),
      size(std::move(size_in)) {}

StartAndSize::~StartAndSize() = default;
size_t StartAndSize::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->start);
  seed = mojo::internal::Hash(seed, this->size);
  return seed;
}

void StartAndSize::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "start"), this->start,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "size"), this->size,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool StartAndSize::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Slice::Slice()
    : input_operand_id(),
      output_operand_id(),
      starts_and_sizes() {}

Slice::Slice(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::vector<StartAndSizePtr> starts_and_sizes_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      starts_and_sizes(std::move(starts_and_sizes_in)) {}

Slice::~Slice() = default;

void Slice::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "starts_and_sizes"), this->starts_and_sizes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<StartAndSizePtr>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Slice::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Elu::Elu()
    : input_operand_id(),
      output_operand_id(),
      alpha(1.0f) {}

Elu::Elu(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float alpha_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      alpha(std::move(alpha_in)) {}

Elu::~Elu() = default;
size_t Elu::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->alpha);
  return seed;
}

void Elu::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "alpha"), this->alpha,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Elu::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Gather::Gather()
    : input_operand_id(),
      indices_operand_id(),
      output_operand_id(),
      axis(0U) {}

Gather::Gather(
    uint64_t input_operand_id_in,
    uint64_t indices_operand_id_in,
    uint64_t output_operand_id_in,
    uint32_t axis_in)
    : input_operand_id(std::move(input_operand_id_in)),
      indices_operand_id(std::move(indices_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      axis(std::move(axis_in)) {}

Gather::~Gather() = default;
size_t Gather::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->indices_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->axis);
  return seed;
}

void Gather::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "indices_operand_id"), this->indices_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axis"), this->axis,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Gather::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Gemm::Gemm()
    : a_operand_id(),
      b_operand_id(),
      output_operand_id(),
      c_operand_id(),
      alpha(1.0f),
      beta(1.0f),
      a_transpose(false),
      b_transpose(false) {}

Gemm::Gemm(
    uint64_t a_operand_id_in,
    uint64_t b_operand_id_in,
    uint64_t output_operand_id_in,
    std::optional<uint64_t> c_operand_id_in,
    float alpha_in,
    float beta_in,
    bool a_transpose_in,
    bool b_transpose_in)
    : a_operand_id(std::move(a_operand_id_in)),
      b_operand_id(std::move(b_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      c_operand_id(std::move(c_operand_id_in)),
      alpha(std::move(alpha_in)),
      beta(std::move(beta_in)),
      a_transpose(std::move(a_transpose_in)),
      b_transpose(std::move(b_transpose_in)) {}

Gemm::~Gemm() = default;

void Gemm::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "a_operand_id"), this->a_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "b_operand_id"), this->b_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "c_operand_id"), this->c_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "alpha"), this->alpha,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "beta"), this->beta,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "a_transpose"), this->a_transpose,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "b_transpose"), this->b_transpose,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Gemm::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
HardSigmoid::HardSigmoid()
    : input_operand_id(),
      output_operand_id(),
      alpha(0.2f),
      beta(0.5f) {}

HardSigmoid::HardSigmoid(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float alpha_in,
    float beta_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      alpha(std::move(alpha_in)),
      beta(std::move(beta_in)) {}

HardSigmoid::~HardSigmoid() = default;
size_t HardSigmoid::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->alpha);
  seed = mojo::internal::Hash(seed, this->beta);
  return seed;
}

void HardSigmoid::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "alpha"), this->alpha,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "beta"), this->beta,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool HardSigmoid::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
LayerNormalization::LayerNormalization()
    : input_operand_id(),
      output_operand_id(),
      scale_operand_id(),
      bias_operand_id(),
      axes(),
      epsilon(1e-5f) {}

LayerNormalization::LayerNormalization(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::optional<uint64_t> scale_operand_id_in,
    std::optional<uint64_t> bias_operand_id_in,
    std::vector<uint32_t> axes_in,
    float epsilon_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      scale_operand_id(std::move(scale_operand_id_in)),
      bias_operand_id(std::move(bias_operand_id_in)),
      axes(std::move(axes_in)),
      epsilon(std::move(epsilon_in)) {}

LayerNormalization::~LayerNormalization() = default;

void LayerNormalization::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "scale_operand_id"), this->scale_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "bias_operand_id"), this->bias_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint64_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axes"), this->axes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "epsilon"), this->epsilon,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool LayerNormalization::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
LeakyRelu::LeakyRelu()
    : input_operand_id(),
      output_operand_id(),
      alpha(0.01f) {}

LeakyRelu::LeakyRelu(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float alpha_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      alpha(std::move(alpha_in)) {}

LeakyRelu::~LeakyRelu() = default;
size_t LeakyRelu::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->alpha);
  return seed;
}

void LeakyRelu::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "alpha"), this->alpha,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool LeakyRelu::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Linear::Linear()
    : input_operand_id(),
      output_operand_id(),
      alpha(1.0f),
      beta(0) {}

Linear::Linear(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float alpha_in,
    float beta_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      alpha(std::move(alpha_in)),
      beta(std::move(beta_in)) {}

Linear::~Linear() = default;
size_t Linear::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->alpha);
  seed = mojo::internal::Hash(seed, this->beta);
  return seed;
}

void Linear::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "alpha"), this->alpha,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "beta"), this->beta,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Linear::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Prelu::Prelu()
    : input_operand_id(),
      slope_operand_id(),
      output_operand_id() {}

Prelu::Prelu(
    uint64_t input_operand_id_in,
    uint64_t slope_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      slope_operand_id(std::move(slope_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Prelu::~Prelu() = default;
size_t Prelu::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->slope_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Prelu::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "slope_operand_id"), this->slope_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Prelu::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Relu::Relu()
    : input_operand_id(),
      output_operand_id() {}

Relu::Relu(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Relu::~Relu() = default;
size_t Relu::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Relu::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Relu::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Reshape::Reshape()
    : input_operand_id(),
      output_operand_id() {}

Reshape::Reshape(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Reshape::~Reshape() = default;
size_t Reshape::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Reshape::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Reshape::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Sigmoid::Sigmoid()
    : input_operand_id(),
      output_operand_id() {}

Sigmoid::Sigmoid(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Sigmoid::~Sigmoid() = default;
size_t Sigmoid::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Sigmoid::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Sigmoid::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Softmax::Softmax()
    : input_operand_id(),
      output_operand_id() {}

Softmax::Softmax(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Softmax::~Softmax() = default;
size_t Softmax::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Softmax::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Softmax::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Softplus::Softplus()
    : input_operand_id(),
      output_operand_id(),
      steepness(1.0f) {}

Softplus::Softplus(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    float steepness_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      steepness(std::move(steepness_in)) {}

Softplus::~Softplus() = default;
size_t Softplus::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  seed = mojo::internal::Hash(seed, this->steepness);
  return seed;
}

void Softplus::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "steepness"), this->steepness,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type float>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Softplus::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Softsign::Softsign()
    : input_operand_id(),
      output_operand_id() {}

Softsign::Softsign(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Softsign::~Softsign() = default;
size_t Softsign::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Softsign::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Softsign::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Split::Split()
    : input_operand_id(),
      output_operand_ids(),
      axis(0U) {}

Split::Split(
    uint64_t input_operand_id_in,
    std::vector<uint64_t> output_operand_ids_in,
    uint32_t axis_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_ids(std::move(output_operand_ids_in)),
      axis(std::move(axis_in)) {}

Split::~Split() = default;

void Split::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_ids"), this->output_operand_ids,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint64_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axis"), this->axis,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Split::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Tanh::Tanh()
    : input_operand_id(),
      output_operand_id() {}

Tanh::Tanh(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Tanh::~Tanh() = default;
size_t Tanh::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->input_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Tanh::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Tanh::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Transpose::Transpose()
    : input_operand_id(),
      output_operand_id(),
      permutation() {}

Transpose::Transpose(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    std::vector<uint32_t> permutation_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      permutation(std::move(permutation_in)) {}

Transpose::~Transpose() = default;

void Transpose::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "permutation"), this->permutation,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Transpose::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Resample2d::Resample2d()
    : input_operand_id(),
      output_operand_id(),
      mode(),
      scales(),
      axes() {}

Resample2d::Resample2d(
    uint64_t input_operand_id_in,
    uint64_t output_operand_id_in,
    Resample2d::InterpolationMode mode_in,
    std::optional<std::vector<float>> scales_in,
    std::vector<uint32_t> axes_in)
    : input_operand_id(std::move(input_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)),
      mode(std::move(mode_in)),
      scales(std::move(scales_in)),
      axes(std::move(axes_in)) {}

Resample2d::~Resample2d() = default;

void Resample2d::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operand_id"), this->input_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "mode"), this->mode,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type Resample2d::InterpolationMode>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "scales"), this->scales,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::optional<std::vector<float>>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "axes"), this->axes,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Resample2d::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
Where::Where()
    : condition_operand_id(),
      true_value_operand_id(),
      false_value_operand_id(),
      output_operand_id() {}

Where::Where(
    uint64_t condition_operand_id_in,
    uint64_t true_value_operand_id_in,
    uint64_t false_value_operand_id_in,
    uint64_t output_operand_id_in)
    : condition_operand_id(std::move(condition_operand_id_in)),
      true_value_operand_id(std::move(true_value_operand_id_in)),
      false_value_operand_id(std::move(false_value_operand_id_in)),
      output_operand_id(std::move(output_operand_id_in)) {}

Where::~Where() = default;
size_t Where::Hash(size_t seed) const {
  seed = mojo::internal::Hash(seed, this->condition_operand_id);
  seed = mojo::internal::Hash(seed, this->true_value_operand_id);
  seed = mojo::internal::Hash(seed, this->false_value_operand_id);
  seed = mojo::internal::Hash(seed, this->output_operand_id);
  return seed;
}

void Where::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "condition_operand_id"), this->condition_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "true_value_operand_id"), this->true_value_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "false_value_operand_id"), this->false_value_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operand_id"), this->output_operand_id,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint64_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool Where::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
GraphInfo::GraphInfo()
    : id_to_operand_map(),
      input_operands(),
      output_operands(),
      operations(),
      constant_id_to_buffer_map() {}

GraphInfo::GraphInfo(
    base::flat_map<uint64_t, OperandPtr> id_to_operand_map_in,
    std::vector<uint64_t> input_operands_in,
    std::vector<uint64_t> output_operands_in,
    std::vector<OperationPtr> operations_in,
    base::flat_map<uint64_t, ::mojo_base::BigBuffer> constant_id_to_buffer_map_in)
    : id_to_operand_map(std::move(id_to_operand_map_in)),
      input_operands(std::move(input_operands_in)),
      output_operands(std::move(output_operands_in)),
      operations(std::move(operations_in)),
      constant_id_to_buffer_map(std::move(constant_id_to_buffer_map_in)) {}

GraphInfo::~GraphInfo() = default;

void GraphInfo::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "id_to_operand_map"), this->id_to_operand_map,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type base::flat_map<uint64_t, OperandPtr>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "input_operands"), this->input_operands,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint64_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "output_operands"), this->output_operands,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint64_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "operations"), this->operations,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::vector<OperationPtr>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "constant_id_to_buffer_map"), this->constant_id_to_buffer_map,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type base::flat_map<uint64_t, ::mojo_base::BigBuffer>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool GraphInfo::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
PaddingMode::PaddingMode() : tag_(Tag::kConstant) {
  data_.constant = new ConstantPaddingPtr;
}

PaddingMode::~PaddingMode() {
  DestroyActive();
}


void PaddingMode::set_constant(
    ConstantPaddingPtr constant) {
  if (tag_ == Tag::kConstant) {
    *(data_.constant) = std::move(constant);
  } else {
    DestroyActive();
    tag_ = Tag::kConstant;
    data_.constant = new ConstantPaddingPtr(
        std::move(constant));
  }
}
void PaddingMode::set_edge(
    EdgePaddingPtr edge) {
  if (tag_ == Tag::kEdge) {
    *(data_.edge) = std::move(edge);
  } else {
    DestroyActive();
    tag_ = Tag::kEdge;
    data_.edge = new EdgePaddingPtr(
        std::move(edge));
  }
}
void PaddingMode::set_reflection(
    ReflectionPaddingPtr reflection) {
  if (tag_ == Tag::kReflection) {
    *(data_.reflection) = std::move(reflection);
  } else {
    DestroyActive();
    tag_ = Tag::kReflection;
    data_.reflection = new ReflectionPaddingPtr(
        std::move(reflection));
  }
}
void PaddingMode::set_symmetric(
    SymmetricPaddingPtr symmetric) {
  if (tag_ == Tag::kSymmetric) {
    *(data_.symmetric) = std::move(symmetric);
  } else {
    DestroyActive();
    tag_ = Tag::kSymmetric;
    data_.symmetric = new SymmetricPaddingPtr(
        std::move(symmetric));
  }
}

void PaddingMode::DestroyActive() {
  switch (tag_) {

    case Tag::kConstant:

      delete data_.constant;
      break;
    case Tag::kEdge:

      delete data_.edge;
      break;
    case Tag::kReflection:

      delete data_.reflection;
      break;
    case Tag::kSymmetric:

      delete data_.symmetric;
      break;
  }
}
size_t PaddingMode::Hash(size_t seed) const {
  seed = mojo::internal::HashCombine(seed, static_cast<uint32_t>(tag_));
  switch (tag_) {

    case Tag::kConstant:
      return mojo::internal::Hash(seed, data_.constant);
    case Tag::kEdge:
      return mojo::internal::Hash(seed, data_.edge);
    case Tag::kReflection:
      return mojo::internal::Hash(seed, data_.reflection);
    case Tag::kSymmetric:
      return mojo::internal::Hash(seed, data_.symmetric);
    default:
      NOTREACHED();
      return seed;
  }
}

bool PaddingMode::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
Activation::Activation() : tag_(Tag::kClamp) {
  data_.clamp = new ClampPtr;
}

Activation::~Activation() {
  DestroyActive();
}


void Activation::set_clamp(
    ClampPtr clamp) {
  if (tag_ == Tag::kClamp) {
    *(data_.clamp) = std::move(clamp);
  } else {
    DestroyActive();
    tag_ = Tag::kClamp;
    data_.clamp = new ClampPtr(
        std::move(clamp));
  }
}
void Activation::set_elu(
    EluPtr elu) {
  if (tag_ == Tag::kElu) {
    *(data_.elu) = std::move(elu);
  } else {
    DestroyActive();
    tag_ = Tag::kElu;
    data_.elu = new EluPtr(
        std::move(elu));
  }
}
void Activation::set_hard_sigmoid(
    HardSigmoidPtr hard_sigmoid) {
  if (tag_ == Tag::kHardSigmoid) {
    *(data_.hard_sigmoid) = std::move(hard_sigmoid);
  } else {
    DestroyActive();
    tag_ = Tag::kHardSigmoid;
    data_.hard_sigmoid = new HardSigmoidPtr(
        std::move(hard_sigmoid));
  }
}
void Activation::set_leaky_relu(
    LeakyReluPtr leaky_relu) {
  if (tag_ == Tag::kLeakyRelu) {
    *(data_.leaky_relu) = std::move(leaky_relu);
  } else {
    DestroyActive();
    tag_ = Tag::kLeakyRelu;
    data_.leaky_relu = new LeakyReluPtr(
        std::move(leaky_relu));
  }
}
void Activation::set_linear(
    LinearPtr linear) {
  if (tag_ == Tag::kLinear) {
    *(data_.linear) = std::move(linear);
  } else {
    DestroyActive();
    tag_ = Tag::kLinear;
    data_.linear = new LinearPtr(
        std::move(linear));
  }
}
void Activation::set_relu(
    ReluPtr relu) {
  if (tag_ == Tag::kRelu) {
    *(data_.relu) = std::move(relu);
  } else {
    DestroyActive();
    tag_ = Tag::kRelu;
    data_.relu = new ReluPtr(
        std::move(relu));
  }
}
void Activation::set_sigmoid(
    SigmoidPtr sigmoid) {
  if (tag_ == Tag::kSigmoid) {
    *(data_.sigmoid) = std::move(sigmoid);
  } else {
    DestroyActive();
    tag_ = Tag::kSigmoid;
    data_.sigmoid = new SigmoidPtr(
        std::move(sigmoid));
  }
}
void Activation::set_softmax(
    SoftmaxPtr softmax) {
  if (tag_ == Tag::kSoftmax) {
    *(data_.softmax) = std::move(softmax);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftmax;
    data_.softmax = new SoftmaxPtr(
        std::move(softmax));
  }
}
void Activation::set_softplus(
    SoftplusPtr softplus) {
  if (tag_ == Tag::kSoftplus) {
    *(data_.softplus) = std::move(softplus);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftplus;
    data_.softplus = new SoftplusPtr(
        std::move(softplus));
  }
}
void Activation::set_softsign(
    SoftsignPtr softsign) {
  if (tag_ == Tag::kSoftsign) {
    *(data_.softsign) = std::move(softsign);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftsign;
    data_.softsign = new SoftsignPtr(
        std::move(softsign));
  }
}
void Activation::set_tanh(
    TanhPtr tanh) {
  if (tag_ == Tag::kTanh) {
    *(data_.tanh) = std::move(tanh);
  } else {
    DestroyActive();
    tag_ = Tag::kTanh;
    data_.tanh = new TanhPtr(
        std::move(tanh));
  }
}

void Activation::DestroyActive() {
  switch (tag_) {

    case Tag::kClamp:

      delete data_.clamp;
      break;
    case Tag::kElu:

      delete data_.elu;
      break;
    case Tag::kHardSigmoid:

      delete data_.hard_sigmoid;
      break;
    case Tag::kLeakyRelu:

      delete data_.leaky_relu;
      break;
    case Tag::kLinear:

      delete data_.linear;
      break;
    case Tag::kRelu:

      delete data_.relu;
      break;
    case Tag::kSigmoid:

      delete data_.sigmoid;
      break;
    case Tag::kSoftmax:

      delete data_.softmax;
      break;
    case Tag::kSoftplus:

      delete data_.softplus;
      break;
    case Tag::kSoftsign:

      delete data_.softsign;
      break;
    case Tag::kTanh:

      delete data_.tanh;
      break;
  }
}
size_t Activation::Hash(size_t seed) const {
  seed = mojo::internal::HashCombine(seed, static_cast<uint32_t>(tag_));
  switch (tag_) {

    case Tag::kClamp:
      return mojo::internal::Hash(seed, data_.clamp);
    case Tag::kElu:
      return mojo::internal::Hash(seed, data_.elu);
    case Tag::kHardSigmoid:
      return mojo::internal::Hash(seed, data_.hard_sigmoid);
    case Tag::kLeakyRelu:
      return mojo::internal::Hash(seed, data_.leaky_relu);
    case Tag::kLinear:
      return mojo::internal::Hash(seed, data_.linear);
    case Tag::kRelu:
      return mojo::internal::Hash(seed, data_.relu);
    case Tag::kSigmoid:
      return mojo::internal::Hash(seed, data_.sigmoid);
    case Tag::kSoftmax:
      return mojo::internal::Hash(seed, data_.softmax);
    case Tag::kSoftplus:
      return mojo::internal::Hash(seed, data_.softplus);
    case Tag::kSoftsign:
      return mojo::internal::Hash(seed, data_.softsign);
    case Tag::kTanh:
      return mojo::internal::Hash(seed, data_.tanh);
    default:
      NOTREACHED();
      return seed;
  }
}

bool Activation::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
Operation::Operation() : tag_(Tag::kArgMinMax) {
  data_.arg_min_max = new ArgMinMaxPtr;
}

Operation::~Operation() {
  DestroyActive();
}


void Operation::set_arg_min_max(
    ArgMinMaxPtr arg_min_max) {
  if (tag_ == Tag::kArgMinMax) {
    *(data_.arg_min_max) = std::move(arg_min_max);
  } else {
    DestroyActive();
    tag_ = Tag::kArgMinMax;
    data_.arg_min_max = new ArgMinMaxPtr(
        std::move(arg_min_max));
  }
}
void Operation::set_batch_normalization(
    BatchNormalizationPtr batch_normalization) {
  if (tag_ == Tag::kBatchNormalization) {
    *(data_.batch_normalization) = std::move(batch_normalization);
  } else {
    DestroyActive();
    tag_ = Tag::kBatchNormalization;
    data_.batch_normalization = new BatchNormalizationPtr(
        std::move(batch_normalization));
  }
}
void Operation::set_clamp(
    ClampPtr clamp) {
  if (tag_ == Tag::kClamp) {
    *(data_.clamp) = std::move(clamp);
  } else {
    DestroyActive();
    tag_ = Tag::kClamp;
    data_.clamp = new ClampPtr(
        std::move(clamp));
  }
}
void Operation::set_concat(
    ConcatPtr concat) {
  if (tag_ == Tag::kConcat) {
    *(data_.concat) = std::move(concat);
  } else {
    DestroyActive();
    tag_ = Tag::kConcat;
    data_.concat = new ConcatPtr(
        std::move(concat));
  }
}
void Operation::set_conv2d(
    Conv2dPtr conv2d) {
  if (tag_ == Tag::kConv2d) {
    *(data_.conv2d) = std::move(conv2d);
  } else {
    DestroyActive();
    tag_ = Tag::kConv2d;
    data_.conv2d = new Conv2dPtr(
        std::move(conv2d));
  }
}
void Operation::set_element_wise_binary(
    ElementWiseBinaryPtr element_wise_binary) {
  if (tag_ == Tag::kElementWiseBinary) {
    *(data_.element_wise_binary) = std::move(element_wise_binary);
  } else {
    DestroyActive();
    tag_ = Tag::kElementWiseBinary;
    data_.element_wise_binary = new ElementWiseBinaryPtr(
        std::move(element_wise_binary));
  }
}
void Operation::set_elu(
    EluPtr elu) {
  if (tag_ == Tag::kElu) {
    *(data_.elu) = std::move(elu);
  } else {
    DestroyActive();
    tag_ = Tag::kElu;
    data_.elu = new EluPtr(
        std::move(elu));
  }
}
void Operation::set_element_wise_unary(
    ElementWiseUnaryPtr element_wise_unary) {
  if (tag_ == Tag::kElementWiseUnary) {
    *(data_.element_wise_unary) = std::move(element_wise_unary);
  } else {
    DestroyActive();
    tag_ = Tag::kElementWiseUnary;
    data_.element_wise_unary = new ElementWiseUnaryPtr(
        std::move(element_wise_unary));
  }
}
void Operation::set_expand(
    ExpandPtr expand) {
  if (tag_ == Tag::kExpand) {
    *(data_.expand) = std::move(expand);
  } else {
    DestroyActive();
    tag_ = Tag::kExpand;
    data_.expand = new ExpandPtr(
        std::move(expand));
  }
}
void Operation::set_gather(
    GatherPtr gather) {
  if (tag_ == Tag::kGather) {
    *(data_.gather) = std::move(gather);
  } else {
    DestroyActive();
    tag_ = Tag::kGather;
    data_.gather = new GatherPtr(
        std::move(gather));
  }
}
void Operation::set_gemm(
    GemmPtr gemm) {
  if (tag_ == Tag::kGemm) {
    *(data_.gemm) = std::move(gemm);
  } else {
    DestroyActive();
    tag_ = Tag::kGemm;
    data_.gemm = new GemmPtr(
        std::move(gemm));
  }
}
void Operation::set_hard_sigmoid(
    HardSigmoidPtr hard_sigmoid) {
  if (tag_ == Tag::kHardSigmoid) {
    *(data_.hard_sigmoid) = std::move(hard_sigmoid);
  } else {
    DestroyActive();
    tag_ = Tag::kHardSigmoid;
    data_.hard_sigmoid = new HardSigmoidPtr(
        std::move(hard_sigmoid));
  }
}
void Operation::set_layer_normalization(
    LayerNormalizationPtr layer_normalization) {
  if (tag_ == Tag::kLayerNormalization) {
    *(data_.layer_normalization) = std::move(layer_normalization);
  } else {
    DestroyActive();
    tag_ = Tag::kLayerNormalization;
    data_.layer_normalization = new LayerNormalizationPtr(
        std::move(layer_normalization));
  }
}
void Operation::set_instance_normalization(
    InstanceNormalizationPtr instance_normalization) {
  if (tag_ == Tag::kInstanceNormalization) {
    *(data_.instance_normalization) = std::move(instance_normalization);
  } else {
    DestroyActive();
    tag_ = Tag::kInstanceNormalization;
    data_.instance_normalization = new InstanceNormalizationPtr(
        std::move(instance_normalization));
  }
}
void Operation::set_leaky_relu(
    LeakyReluPtr leaky_relu) {
  if (tag_ == Tag::kLeakyRelu) {
    *(data_.leaky_relu) = std::move(leaky_relu);
  } else {
    DestroyActive();
    tag_ = Tag::kLeakyRelu;
    data_.leaky_relu = new LeakyReluPtr(
        std::move(leaky_relu));
  }
}
void Operation::set_linear(
    LinearPtr linear) {
  if (tag_ == Tag::kLinear) {
    *(data_.linear) = std::move(linear);
  } else {
    DestroyActive();
    tag_ = Tag::kLinear;
    data_.linear = new LinearPtr(
        std::move(linear));
  }
}
void Operation::set_matmul(
    MatmulPtr matmul) {
  if (tag_ == Tag::kMatmul) {
    *(data_.matmul) = std::move(matmul);
  } else {
    DestroyActive();
    tag_ = Tag::kMatmul;
    data_.matmul = new MatmulPtr(
        std::move(matmul));
  }
}
void Operation::set_pad(
    PadPtr pad) {
  if (tag_ == Tag::kPad) {
    *(data_.pad) = std::move(pad);
  } else {
    DestroyActive();
    tag_ = Tag::kPad;
    data_.pad = new PadPtr(
        std::move(pad));
  }
}
void Operation::set_pool2d(
    Pool2dPtr pool2d) {
  if (tag_ == Tag::kPool2d) {
    *(data_.pool2d) = std::move(pool2d);
  } else {
    DestroyActive();
    tag_ = Tag::kPool2d;
    data_.pool2d = new Pool2dPtr(
        std::move(pool2d));
  }
}
void Operation::set_prelu(
    PreluPtr prelu) {
  if (tag_ == Tag::kPrelu) {
    *(data_.prelu) = std::move(prelu);
  } else {
    DestroyActive();
    tag_ = Tag::kPrelu;
    data_.prelu = new PreluPtr(
        std::move(prelu));
  }
}
void Operation::set_reduce(
    ReducePtr reduce) {
  if (tag_ == Tag::kReduce) {
    *(data_.reduce) = std::move(reduce);
  } else {
    DestroyActive();
    tag_ = Tag::kReduce;
    data_.reduce = new ReducePtr(
        std::move(reduce));
  }
}
void Operation::set_relu(
    ReluPtr relu) {
  if (tag_ == Tag::kRelu) {
    *(data_.relu) = std::move(relu);
  } else {
    DestroyActive();
    tag_ = Tag::kRelu;
    data_.relu = new ReluPtr(
        std::move(relu));
  }
}
void Operation::set_resample2d(
    Resample2dPtr resample2d) {
  if (tag_ == Tag::kResample2d) {
    *(data_.resample2d) = std::move(resample2d);
  } else {
    DestroyActive();
    tag_ = Tag::kResample2d;
    data_.resample2d = new Resample2dPtr(
        std::move(resample2d));
  }
}
void Operation::set_reshape(
    ReshapePtr reshape) {
  if (tag_ == Tag::kReshape) {
    *(data_.reshape) = std::move(reshape);
  } else {
    DestroyActive();
    tag_ = Tag::kReshape;
    data_.reshape = new ReshapePtr(
        std::move(reshape));
  }
}
void Operation::set_sigmoid(
    SigmoidPtr sigmoid) {
  if (tag_ == Tag::kSigmoid) {
    *(data_.sigmoid) = std::move(sigmoid);
  } else {
    DestroyActive();
    tag_ = Tag::kSigmoid;
    data_.sigmoid = new SigmoidPtr(
        std::move(sigmoid));
  }
}
void Operation::set_slice(
    SlicePtr slice) {
  if (tag_ == Tag::kSlice) {
    *(data_.slice) = std::move(slice);
  } else {
    DestroyActive();
    tag_ = Tag::kSlice;
    data_.slice = new SlicePtr(
        std::move(slice));
  }
}
void Operation::set_softmax(
    SoftmaxPtr softmax) {
  if (tag_ == Tag::kSoftmax) {
    *(data_.softmax) = std::move(softmax);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftmax;
    data_.softmax = new SoftmaxPtr(
        std::move(softmax));
  }
}
void Operation::set_softplus(
    SoftplusPtr softplus) {
  if (tag_ == Tag::kSoftplus) {
    *(data_.softplus) = std::move(softplus);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftplus;
    data_.softplus = new SoftplusPtr(
        std::move(softplus));
  }
}
void Operation::set_softsign(
    SoftsignPtr softsign) {
  if (tag_ == Tag::kSoftsign) {
    *(data_.softsign) = std::move(softsign);
  } else {
    DestroyActive();
    tag_ = Tag::kSoftsign;
    data_.softsign = new SoftsignPtr(
        std::move(softsign));
  }
}
void Operation::set_split(
    SplitPtr split) {
  if (tag_ == Tag::kSplit) {
    *(data_.split) = std::move(split);
  } else {
    DestroyActive();
    tag_ = Tag::kSplit;
    data_.split = new SplitPtr(
        std::move(split));
  }
}
void Operation::set_tanh(
    TanhPtr tanh) {
  if (tag_ == Tag::kTanh) {
    *(data_.tanh) = std::move(tanh);
  } else {
    DestroyActive();
    tag_ = Tag::kTanh;
    data_.tanh = new TanhPtr(
        std::move(tanh));
  }
}
void Operation::set_transpose(
    TransposePtr transpose) {
  if (tag_ == Tag::kTranspose) {
    *(data_.transpose) = std::move(transpose);
  } else {
    DestroyActive();
    tag_ = Tag::kTranspose;
    data_.transpose = new TransposePtr(
        std::move(transpose));
  }
}
void Operation::set_where(
    WherePtr where) {
  if (tag_ == Tag::kWhere) {
    *(data_.where) = std::move(where);
  } else {
    DestroyActive();
    tag_ = Tag::kWhere;
    data_.where = new WherePtr(
        std::move(where));
  }
}

void Operation::DestroyActive() {
  switch (tag_) {

    case Tag::kArgMinMax:

      delete data_.arg_min_max;
      break;
    case Tag::kBatchNormalization:

      delete data_.batch_normalization;
      break;
    case Tag::kClamp:

      delete data_.clamp;
      break;
    case Tag::kConcat:

      delete data_.concat;
      break;
    case Tag::kConv2d:

      delete data_.conv2d;
      break;
    case Tag::kElementWiseBinary:

      delete data_.element_wise_binary;
      break;
    case Tag::kElu:

      delete data_.elu;
      break;
    case Tag::kElementWiseUnary:

      delete data_.element_wise_unary;
      break;
    case Tag::kExpand:

      delete data_.expand;
      break;
    case Tag::kGather:

      delete data_.gather;
      break;
    case Tag::kGemm:

      delete data_.gemm;
      break;
    case Tag::kHardSigmoid:

      delete data_.hard_sigmoid;
      break;
    case Tag::kLayerNormalization:

      delete data_.layer_normalization;
      break;
    case Tag::kInstanceNormalization:

      delete data_.instance_normalization;
      break;
    case Tag::kLeakyRelu:

      delete data_.leaky_relu;
      break;
    case Tag::kLinear:

      delete data_.linear;
      break;
    case Tag::kMatmul:

      delete data_.matmul;
      break;
    case Tag::kPad:

      delete data_.pad;
      break;
    case Tag::kPool2d:

      delete data_.pool2d;
      break;
    case Tag::kPrelu:

      delete data_.prelu;
      break;
    case Tag::kReduce:

      delete data_.reduce;
      break;
    case Tag::kRelu:

      delete data_.relu;
      break;
    case Tag::kResample2d:

      delete data_.resample2d;
      break;
    case Tag::kReshape:

      delete data_.reshape;
      break;
    case Tag::kSigmoid:

      delete data_.sigmoid;
      break;
    case Tag::kSlice:

      delete data_.slice;
      break;
    case Tag::kSoftmax:

      delete data_.softmax;
      break;
    case Tag::kSoftplus:

      delete data_.softplus;
      break;
    case Tag::kSoftsign:

      delete data_.softsign;
      break;
    case Tag::kSplit:

      delete data_.split;
      break;
    case Tag::kTanh:

      delete data_.tanh;
      break;
    case Tag::kTranspose:

      delete data_.transpose;
      break;
    case Tag::kWhere:

      delete data_.where;
      break;
  }
}

bool Operation::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
ComputeResult::ComputeResult() : tag_(Tag::kNamedOutputs) {
  data_.named_outputs = new base::flat_map<std::string, ::mojo_base::BigBuffer>;
}

ComputeResult::~ComputeResult() {
  DestroyActive();
}


void ComputeResult::set_named_outputs(
    base::flat_map<std::string, ::mojo_base::BigBuffer> named_outputs) {
  if (tag_ == Tag::kNamedOutputs) {
    *(data_.named_outputs) = std::move(named_outputs);
  } else {
    DestroyActive();
    tag_ = Tag::kNamedOutputs;
    data_.named_outputs = new base::flat_map<std::string, ::mojo_base::BigBuffer>(
        std::move(named_outputs));
  }
}
void ComputeResult::set_error(
    ::webnn::mojom::ErrorPtr error) {
  if (tag_ == Tag::kError) {
    *(data_.error) = std::move(error);
  } else {
    DestroyActive();
    tag_ = Tag::kError;
    data_.error = new ::webnn::mojom::ErrorPtr(
        std::move(error));
  }
}

void ComputeResult::DestroyActive() {
  switch (tag_) {

    case Tag::kNamedOutputs:

      delete data_.named_outputs;
      break;
    case Tag::kError:

      delete data_.error;
      break;
  }
}

bool ComputeResult::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context, false);
}
const char WebNNGraph::Name_[] = "webnn.mojom.WebNNGraph";

WebNNGraph::IPCStableHashFunction WebNNGraph::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (message.name()) {
    case internal::kWebNNGraph_Compute_Name: {
      return &WebNNGraph::Compute_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* WebNNGraph::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (message.name()) {
      case internal::kWebNNGraph_Compute_Name:
            return "Receive webnn::mojom::WebNNGraph::Compute";
    }
  } else {
    switch (message.name()) {
      case internal::kWebNNGraph_Compute_Name:
            return "Receive reply webnn::mojom::WebNNGraph::Compute";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t WebNNGraph::Compute_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)webnn::mojom::WebNNGraph::Compute");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)
bool WebNNGraph::Compute(base::flat_map<std::string, ::mojo_base::BigBuffer> named_inputs, ComputeResultPtr* out_result) {
  NOTREACHED();
  return false;
}
class WebNNGraph_Compute_HandleSyncResponse
    : public mojo::MessageReceiver {
 public:
  WebNNGraph_Compute_HandleSyncResponse(
      bool* result, ComputeResultPtr* out_result)
      : result_(result), out_result_(out_result) {
    DCHECK(!*result_);
  }

  WebNNGraph_Compute_HandleSyncResponse(const WebNNGraph_Compute_HandleSyncResponse&) = delete;
  WebNNGraph_Compute_HandleSyncResponse& operator=(const WebNNGraph_Compute_HandleSyncResponse&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  bool* result_;
  ComputeResultPtr* out_result_;};

class WebNNGraph_Compute_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  WebNNGraph_Compute_ForwardToCallback(
      WebNNGraph::ComputeCallback callback
      ) : callback_(std::move(callback)) {
  }

  WebNNGraph_Compute_ForwardToCallback(const WebNNGraph_Compute_ForwardToCallback&) = delete;
  WebNNGraph_Compute_ForwardToCallback& operator=(const WebNNGraph_Compute_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  WebNNGraph::ComputeCallback callback_;
};

WebNNGraphProxy::WebNNGraphProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}
bool WebNNGraphProxy::Compute(
    base::flat_map<std::string, ::mojo_base::BigBuffer> param_named_inputs, ComputeResultPtr* out_param_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT_BEGIN1(
    "mojom", "Call webnn::mojom::WebNNGraph::Compute (sync)", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("named_inputs"), param_named_inputs,
                        "<value of type base::flat_map<std::string, ::mojo_base::BigBuffer>>");
   });
#else
  TRACE_EVENT0("mojom", "WebNNGraph::Compute");
#endif
  
  const bool kExpectsResponse = true;
  const bool kIsSync = true;
  const bool kAllowInterrupt =
      true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kWebNNGraph_Compute_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNGraph_Compute_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->named_inputs)::BaseType>
      named_inputs_fragment(params.message());
  constexpr const mojo::internal::ContainerValidateParams& named_inputs_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, ::mojo_base::mojom::BigBufferDataView>>(
      param_named_inputs, named_inputs_fragment, &named_inputs_validate_params);
  params->named_inputs.Set(
      named_inputs_fragment.is_null() ? nullptr : named_inputs_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->named_inputs.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null named_inputs in WebNNGraph.Compute request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNGraph::Name_);
  message.set_method_name("Compute");
#endif

  bool result = false;
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNGraph_Compute_HandleSyncResponse(
          &result, out_param_result));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT_END1(
    "mojom", "WebNNGraph::Compute", "sync_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), out_param_result,
                        "<value of type ComputeResultPtr>");
   });
#endif
  return result;
}

void WebNNGraphProxy::Compute(
    base::flat_map<std::string, ::mojo_base::BigBuffer> in_named_inputs, ComputeCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send webnn::mojom::WebNNGraph::Compute", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("named_inputs"), in_named_inputs,
                        "<value of type base::flat_map<std::string, ::mojo_base::BigBuffer>>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;
  
  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kWebNNGraph_Compute_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNGraph_Compute_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->named_inputs)::BaseType>
      named_inputs_fragment(params.message());
  constexpr const mojo::internal::ContainerValidateParams& named_inputs_validate_params =
      mojo::internal::GetMapValidator<*&mojo::internal::GetArrayValidator<0, false, &mojo::internal::GetArrayValidator<0, false, nullptr>()>(), *&mojo::internal::GetArrayValidator<0, false, nullptr>()>();
  mojo::internal::Serialize<mojo::MapDataView<mojo::StringDataView, ::mojo_base::mojom::BigBufferDataView>>(
      in_named_inputs, named_inputs_fragment, &named_inputs_validate_params);
  params->named_inputs.Set(
      named_inputs_fragment.is_null() ? nullptr : named_inputs_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->named_inputs.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null named_inputs in WebNNGraph.Compute request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNGraph::Name_);
  message.set_method_name("Compute");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new WebNNGraph_Compute_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class WebNNGraph_Compute_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static WebNNGraph::ComputeCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<WebNNGraph_Compute_ProxyToResponder> proxy(
        new WebNNGraph_Compute_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&WebNNGraph_Compute_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~WebNNGraph_Compute_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  WebNNGraph_Compute_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
//    DCHECK(!connected)
//        << "WebNNGraph::ComputeCallback was destroyed without "
//        << "first either being run or its corresponding binding being closed. "
//        << "It is an error to drop response callbacks which still correspond "
//        << "to an open interface pipe.";
  }
#endif

  void Run(
      ComputeResultPtr in_result);
};

bool WebNNGraph_Compute_ForwardToCallback::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::WebNNGraph_Compute_ResponseParams_Data* params =
      reinterpret_cast<
          internal::WebNNGraph_Compute_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for WebNNGraph.0
  bool success = true;
  ComputeResultPtr p_result{};
  WebNNGraph_Compute_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNGraph::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void WebNNGraph_Compute_ProxyToResponder::Run(
    ComputeResultPtr in_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply webnn::mojom::WebNNGraph::Compute", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type ComputeResultPtr>");
   });
#endif
  
  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);
  
  mojo::Message message(
      internal::kWebNNGraph_Compute_Name, kFlags, 0, 0, nullptr);
  mojo::internal::MessageFragment<
      ::webnn::mojom::internal::WebNNGraph_Compute_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<decltype(params->result)>
      result_fragment(params.message());
  result_fragment.Claim(&params->result);
  mojo::internal::Serialize<::webnn::mojom::ComputeResultDataView>(
      in_result, result_fragment, true);
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->result.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null result in ");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(WebNNGraph::Name_);
  message.set_method_name("Compute");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
bool WebNNGraph_Compute_HandleSyncResponse::Accept(
    mojo::Message* message) {

  DCHECK(message->is_serialized());
  internal::WebNNGraph_Compute_ResponseParams_Data* params =
      reinterpret_cast<internal::WebNNGraph_Compute_ResponseParams_Data*>(
          message->mutable_payload());
  
  
  // Validation for WebNNGraph.0
  bool success = true;
  ComputeResultPtr p_result{};
  WebNNGraph_Compute_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        WebNNGraph::Name_, 0, true);
    return false;
  }
  *out_result_ = std::move(p_result);
  *result_ = true;
  return true;
}

// static
bool WebNNGraphStubDispatch::Accept(
    WebNNGraph* impl,
    mojo::Message* message) {
  switch (message->header()->name) {
    case internal::kWebNNGraph_Compute_Name: {
      break;
    }
  }
  return false;
}

// static
bool WebNNGraphStubDispatch::AcceptWithResponder(
    WebNNGraph* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (message->header()->name) {
    case internal::kWebNNGraph_Compute_Name: {

      internal::WebNNGraph_Compute_Params_Data* params =
          reinterpret_cast<
              internal::WebNNGraph_Compute_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for WebNNGraph.0
      bool success = true;
      base::flat_map<std::string, ::mojo_base::BigBuffer> p_named_inputs{};
      WebNNGraph_Compute_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadNamedInputs(&p_named_inputs))
        success = false;
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            WebNNGraph::Name_, 0, false);
        return false;
      }
      WebNNGraph::ComputeCallback callback =
          WebNNGraph_Compute_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->Compute(        
        std::move(p_named_inputs), std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kWebNNGraphValidationInfo[] = {
    {internal::kWebNNGraph_Compute_Name,
     { &internal::WebNNGraph_Compute_Params_Data::Validate,
      &internal::WebNNGraph_Compute_ResponseParams_Data::Validate}},
};

bool WebNNGraphRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNGraph::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kWebNNGraphValidationInfo);
}

bool WebNNGraphResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::webnn::mojom::WebNNGraph::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kWebNNGraphValidationInfo);

}


}  // webnn::mojom


namespace mojo {


// static
bool StructTraits<::webnn::mojom::Operand::DataView, ::webnn::mojom::OperandPtr>::Read(
    ::webnn::mojom::Operand::DataView input,
    ::webnn::mojom::OperandPtr* output) {
  bool success = true;
  ::webnn::mojom::OperandPtr result(::webnn::mojom::Operand::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success && !input.ReadDataType(&result->data_type))
        success = false;
      if (success && !input.ReadDimensions(&result->dimensions))
        success = false;
      if (success && !input.ReadName(&result->name))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::ArgMinMax::DataView, ::webnn::mojom::ArgMinMaxPtr>::Read(
    ::webnn::mojom::ArgMinMax::DataView input,
    ::webnn::mojom::ArgMinMaxPtr* output) {
  bool success = true;
  ::webnn::mojom::ArgMinMaxPtr result(::webnn::mojom::ArgMinMax::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadAxes(&result->axes))
        success = false;
      if (success)
        result->keep_dimensions = input.keep_dimensions();
      if (success)
        result->select_last_index = input.select_last_index();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::BatchNormalization::DataView, ::webnn::mojom::BatchNormalizationPtr>::Read(
    ::webnn::mojom::BatchNormalization::DataView input,
    ::webnn::mojom::BatchNormalizationPtr* output) {
  bool success = true;
  ::webnn::mojom::BatchNormalizationPtr result(::webnn::mojom::BatchNormalization::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->mean_operand_id = input.mean_operand_id();
      if (success)
        result->variance_operand_id = input.variance_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success) {
        result->scale_operand_id = input.scale_operand_id();
      }
      if (success) {
        result->bias_operand_id = input.bias_operand_id();
      }
      if (success)
        result->axis = input.axis();
      if (success)
        result->epsilon = input.epsilon();
      if (success && !input.ReadActivation(&result->activation))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Clamp::DataView, ::webnn::mojom::ClampPtr>::Read(
    ::webnn::mojom::Clamp::DataView input,
    ::webnn::mojom::ClampPtr* output) {
  bool success = true;
  ::webnn::mojom::ClampPtr result(::webnn::mojom::Clamp::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->min_value = input.min_value();
      if (success)
        result->max_value = input.max_value();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Concat::DataView, ::webnn::mojom::ConcatPtr>::Read(
    ::webnn::mojom::Concat::DataView input,
    ::webnn::mojom::ConcatPtr* output) {
  bool success = true;
  ::webnn::mojom::ConcatPtr result(::webnn::mojom::Concat::New());
  
      if (success && !input.ReadInputOperandIds(&result->input_operand_ids))
        success = false;
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->axis = input.axis();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Size2d::DataView, ::webnn::mojom::Size2dPtr>::Read(
    ::webnn::mojom::Size2d::DataView input,
    ::webnn::mojom::Size2dPtr* output) {
  bool success = true;
  ::webnn::mojom::Size2dPtr result(::webnn::mojom::Size2d::New());
  
      if (success)
        result->height = input.height();
      if (success)
        result->width = input.width();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Padding2d::DataView, ::webnn::mojom::Padding2dPtr>::Read(
    ::webnn::mojom::Padding2d::DataView input,
    ::webnn::mojom::Padding2dPtr* output) {
  bool success = true;
  ::webnn::mojom::Padding2dPtr result(::webnn::mojom::Padding2d::New());
  
      if (success && !input.ReadBeginning(&result->beginning))
        success = false;
      if (success && !input.ReadEnding(&result->ending))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Conv2d::DataView, ::webnn::mojom::Conv2dPtr>::Read(
    ::webnn::mojom::Conv2d::DataView input,
    ::webnn::mojom::Conv2dPtr* output) {
  bool success = true;
  ::webnn::mojom::Conv2dPtr result(::webnn::mojom::Conv2d::New());
  
      if (success && !input.ReadType(&result->type))
        success = false;
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->filter_operand_id = input.filter_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadPadding(&result->padding))
        success = false;
      if (success && !input.ReadStrides(&result->strides))
        success = false;
      if (success && !input.ReadDilations(&result->dilations))
        success = false;
      if (success)
        result->groups = input.groups();
      if (success && !input.ReadInputLayout(&result->input_layout))
        success = false;
      if (success) {
        result->bias_operand_id = input.bias_operand_id();
      }
      if (success && !input.ReadActivation(&result->activation))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::ElementWiseBinary::DataView, ::webnn::mojom::ElementWiseBinaryPtr>::Read(
    ::webnn::mojom::ElementWiseBinary::DataView input,
    ::webnn::mojom::ElementWiseBinaryPtr* output) {
  bool success = true;
  ::webnn::mojom::ElementWiseBinaryPtr result(::webnn::mojom::ElementWiseBinary::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success)
        result->lhs_operand = input.lhs_operand();
      if (success)
        result->rhs_operand = input.rhs_operand();
      if (success)
        result->output_operand = input.output_operand();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::ElementWiseUnary::DataView, ::webnn::mojom::ElementWiseUnaryPtr>::Read(
    ::webnn::mojom::ElementWiseUnary::DataView input,
    ::webnn::mojom::ElementWiseUnaryPtr* output) {
  bool success = true;
  ::webnn::mojom::ElementWiseUnaryPtr result(::webnn::mojom::ElementWiseUnary::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Expand::DataView, ::webnn::mojom::ExpandPtr>::Read(
    ::webnn::mojom::Expand::DataView input,
    ::webnn::mojom::ExpandPtr* output) {
  bool success = true;
  ::webnn::mojom::ExpandPtr result(::webnn::mojom::Expand::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::ConstantPadding::DataView, ::webnn::mojom::ConstantPaddingPtr>::Read(
    ::webnn::mojom::ConstantPadding::DataView input,
    ::webnn::mojom::ConstantPaddingPtr* output) {
  bool success = true;
  ::webnn::mojom::ConstantPaddingPtr result(::webnn::mojom::ConstantPadding::New());
  
      if (success)
        result->value = input.value();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::EdgePadding::DataView, ::webnn::mojom::EdgePaddingPtr>::Read(
    ::webnn::mojom::EdgePadding::DataView input,
    ::webnn::mojom::EdgePaddingPtr* output) {
  bool success = true;
  ::webnn::mojom::EdgePaddingPtr result(::webnn::mojom::EdgePadding::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::ReflectionPadding::DataView, ::webnn::mojom::ReflectionPaddingPtr>::Read(
    ::webnn::mojom::ReflectionPadding::DataView input,
    ::webnn::mojom::ReflectionPaddingPtr* output) {
  bool success = true;
  ::webnn::mojom::ReflectionPaddingPtr result(::webnn::mojom::ReflectionPadding::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::SymmetricPadding::DataView, ::webnn::mojom::SymmetricPaddingPtr>::Read(
    ::webnn::mojom::SymmetricPadding::DataView input,
    ::webnn::mojom::SymmetricPaddingPtr* output) {
  bool success = true;
  ::webnn::mojom::SymmetricPaddingPtr result(::webnn::mojom::SymmetricPadding::New());
  
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::InstanceNormalization::DataView, ::webnn::mojom::InstanceNormalizationPtr>::Read(
    ::webnn::mojom::InstanceNormalization::DataView input,
    ::webnn::mojom::InstanceNormalizationPtr* output) {
  bool success = true;
  ::webnn::mojom::InstanceNormalizationPtr result(::webnn::mojom::InstanceNormalization::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success) {
        result->scale_operand_id = input.scale_operand_id();
      }
      if (success) {
        result->bias_operand_id = input.bias_operand_id();
      }
      if (success)
        result->epsilon = input.epsilon();
      if (success && !input.ReadLayout(&result->layout))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Matmul::DataView, ::webnn::mojom::MatmulPtr>::Read(
    ::webnn::mojom::Matmul::DataView input,
    ::webnn::mojom::MatmulPtr* output) {
  bool success = true;
  ::webnn::mojom::MatmulPtr result(::webnn::mojom::Matmul::New());
  
      if (success)
        result->a_operand_id = input.a_operand_id();
      if (success)
        result->b_operand_id = input.b_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Pad::DataView, ::webnn::mojom::PadPtr>::Read(
    ::webnn::mojom::Pad::DataView input,
    ::webnn::mojom::PadPtr* output) {
  bool success = true;
  ::webnn::mojom::PadPtr result(::webnn::mojom::Pad::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadBeginningPadding(&result->beginning_padding))
        success = false;
      if (success && !input.ReadEndingPadding(&result->ending_padding))
        success = false;
      if (success && !input.ReadMode(&result->mode))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Reduce::DataView, ::webnn::mojom::ReducePtr>::Read(
    ::webnn::mojom::Reduce::DataView input,
    ::webnn::mojom::ReducePtr* output) {
  bool success = true;
  ::webnn::mojom::ReducePtr result(::webnn::mojom::Reduce::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadAxes(&result->axes))
        success = false;
      if (success)
        result->keep_dimensions = input.keep_dimensions();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Pool2d::DataView, ::webnn::mojom::Pool2dPtr>::Read(
    ::webnn::mojom::Pool2d::DataView input,
    ::webnn::mojom::Pool2dPtr* output) {
  bool success = true;
  ::webnn::mojom::Pool2dPtr result(::webnn::mojom::Pool2d::New());
  
      if (success && !input.ReadKind(&result->kind))
        success = false;
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadWindowDimensions(&result->window_dimensions))
        success = false;
      if (success && !input.ReadPadding(&result->padding))
        success = false;
      if (success && !input.ReadStrides(&result->strides))
        success = false;
      if (success && !input.ReadDilations(&result->dilations))
        success = false;
      if (success && !input.ReadLayout(&result->layout))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::StartAndSize::DataView, ::webnn::mojom::StartAndSizePtr>::Read(
    ::webnn::mojom::StartAndSize::DataView input,
    ::webnn::mojom::StartAndSizePtr* output) {
  bool success = true;
  ::webnn::mojom::StartAndSizePtr result(::webnn::mojom::StartAndSize::New());
  
      if (success)
        result->start = input.start();
      if (success)
        result->size = input.size();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Slice::DataView, ::webnn::mojom::SlicePtr>::Read(
    ::webnn::mojom::Slice::DataView input,
    ::webnn::mojom::SlicePtr* output) {
  bool success = true;
  ::webnn::mojom::SlicePtr result(::webnn::mojom::Slice::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadStartsAndSizes(&result->starts_and_sizes))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Elu::DataView, ::webnn::mojom::EluPtr>::Read(
    ::webnn::mojom::Elu::DataView input,
    ::webnn::mojom::EluPtr* output) {
  bool success = true;
  ::webnn::mojom::EluPtr result(::webnn::mojom::Elu::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->alpha = input.alpha();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Gather::DataView, ::webnn::mojom::GatherPtr>::Read(
    ::webnn::mojom::Gather::DataView input,
    ::webnn::mojom::GatherPtr* output) {
  bool success = true;
  ::webnn::mojom::GatherPtr result(::webnn::mojom::Gather::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->indices_operand_id = input.indices_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->axis = input.axis();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Gemm::DataView, ::webnn::mojom::GemmPtr>::Read(
    ::webnn::mojom::Gemm::DataView input,
    ::webnn::mojom::GemmPtr* output) {
  bool success = true;
  ::webnn::mojom::GemmPtr result(::webnn::mojom::Gemm::New());
  
      if (success)
        result->a_operand_id = input.a_operand_id();
      if (success)
        result->b_operand_id = input.b_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success) {
        result->c_operand_id = input.c_operand_id();
      }
      if (success)
        result->alpha = input.alpha();
      if (success)
        result->beta = input.beta();
      if (success)
        result->a_transpose = input.a_transpose();
      if (success)
        result->b_transpose = input.b_transpose();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::HardSigmoid::DataView, ::webnn::mojom::HardSigmoidPtr>::Read(
    ::webnn::mojom::HardSigmoid::DataView input,
    ::webnn::mojom::HardSigmoidPtr* output) {
  bool success = true;
  ::webnn::mojom::HardSigmoidPtr result(::webnn::mojom::HardSigmoid::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->alpha = input.alpha();
      if (success)
        result->beta = input.beta();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::LayerNormalization::DataView, ::webnn::mojom::LayerNormalizationPtr>::Read(
    ::webnn::mojom::LayerNormalization::DataView input,
    ::webnn::mojom::LayerNormalizationPtr* output) {
  bool success = true;
  ::webnn::mojom::LayerNormalizationPtr result(::webnn::mojom::LayerNormalization::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success) {
        result->scale_operand_id = input.scale_operand_id();
      }
      if (success) {
        result->bias_operand_id = input.bias_operand_id();
      }
      if (success && !input.ReadAxes(&result->axes))
        success = false;
      if (success)
        result->epsilon = input.epsilon();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::LeakyRelu::DataView, ::webnn::mojom::LeakyReluPtr>::Read(
    ::webnn::mojom::LeakyRelu::DataView input,
    ::webnn::mojom::LeakyReluPtr* output) {
  bool success = true;
  ::webnn::mojom::LeakyReluPtr result(::webnn::mojom::LeakyRelu::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->alpha = input.alpha();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Linear::DataView, ::webnn::mojom::LinearPtr>::Read(
    ::webnn::mojom::Linear::DataView input,
    ::webnn::mojom::LinearPtr* output) {
  bool success = true;
  ::webnn::mojom::LinearPtr result(::webnn::mojom::Linear::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->alpha = input.alpha();
      if (success)
        result->beta = input.beta();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Prelu::DataView, ::webnn::mojom::PreluPtr>::Read(
    ::webnn::mojom::Prelu::DataView input,
    ::webnn::mojom::PreluPtr* output) {
  bool success = true;
  ::webnn::mojom::PreluPtr result(::webnn::mojom::Prelu::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->slope_operand_id = input.slope_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Relu::DataView, ::webnn::mojom::ReluPtr>::Read(
    ::webnn::mojom::Relu::DataView input,
    ::webnn::mojom::ReluPtr* output) {
  bool success = true;
  ::webnn::mojom::ReluPtr result(::webnn::mojom::Relu::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Reshape::DataView, ::webnn::mojom::ReshapePtr>::Read(
    ::webnn::mojom::Reshape::DataView input,
    ::webnn::mojom::ReshapePtr* output) {
  bool success = true;
  ::webnn::mojom::ReshapePtr result(::webnn::mojom::Reshape::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Sigmoid::DataView, ::webnn::mojom::SigmoidPtr>::Read(
    ::webnn::mojom::Sigmoid::DataView input,
    ::webnn::mojom::SigmoidPtr* output) {
  bool success = true;
  ::webnn::mojom::SigmoidPtr result(::webnn::mojom::Sigmoid::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Softmax::DataView, ::webnn::mojom::SoftmaxPtr>::Read(
    ::webnn::mojom::Softmax::DataView input,
    ::webnn::mojom::SoftmaxPtr* output) {
  bool success = true;
  ::webnn::mojom::SoftmaxPtr result(::webnn::mojom::Softmax::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Softplus::DataView, ::webnn::mojom::SoftplusPtr>::Read(
    ::webnn::mojom::Softplus::DataView input,
    ::webnn::mojom::SoftplusPtr* output) {
  bool success = true;
  ::webnn::mojom::SoftplusPtr result(::webnn::mojom::Softplus::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success)
        result->steepness = input.steepness();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Softsign::DataView, ::webnn::mojom::SoftsignPtr>::Read(
    ::webnn::mojom::Softsign::DataView input,
    ::webnn::mojom::SoftsignPtr* output) {
  bool success = true;
  ::webnn::mojom::SoftsignPtr result(::webnn::mojom::Softsign::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Split::DataView, ::webnn::mojom::SplitPtr>::Read(
    ::webnn::mojom::Split::DataView input,
    ::webnn::mojom::SplitPtr* output) {
  bool success = true;
  ::webnn::mojom::SplitPtr result(::webnn::mojom::Split::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success && !input.ReadOutputOperandIds(&result->output_operand_ids))
        success = false;
      if (success)
        result->axis = input.axis();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Tanh::DataView, ::webnn::mojom::TanhPtr>::Read(
    ::webnn::mojom::Tanh::DataView input,
    ::webnn::mojom::TanhPtr* output) {
  bool success = true;
  ::webnn::mojom::TanhPtr result(::webnn::mojom::Tanh::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Transpose::DataView, ::webnn::mojom::TransposePtr>::Read(
    ::webnn::mojom::Transpose::DataView input,
    ::webnn::mojom::TransposePtr* output) {
  bool success = true;
  ::webnn::mojom::TransposePtr result(::webnn::mojom::Transpose::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadPermutation(&result->permutation))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Resample2d::DataView, ::webnn::mojom::Resample2dPtr>::Read(
    ::webnn::mojom::Resample2d::DataView input,
    ::webnn::mojom::Resample2dPtr* output) {
  bool success = true;
  ::webnn::mojom::Resample2dPtr result(::webnn::mojom::Resample2d::New());
  
      if (success)
        result->input_operand_id = input.input_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
      if (success && !input.ReadMode(&result->mode))
        success = false;
      if (success && !input.ReadScales(&result->scales))
        success = false;
      if (success && !input.ReadAxes(&result->axes))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::Where::DataView, ::webnn::mojom::WherePtr>::Read(
    ::webnn::mojom::Where::DataView input,
    ::webnn::mojom::WherePtr* output) {
  bool success = true;
  ::webnn::mojom::WherePtr result(::webnn::mojom::Where::New());
  
      if (success)
        result->condition_operand_id = input.condition_operand_id();
      if (success)
        result->true_value_operand_id = input.true_value_operand_id();
      if (success)
        result->false_value_operand_id = input.false_value_operand_id();
      if (success)
        result->output_operand_id = input.output_operand_id();
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::webnn::mojom::GraphInfo::DataView, ::webnn::mojom::GraphInfoPtr>::Read(
    ::webnn::mojom::GraphInfo::DataView input,
    ::webnn::mojom::GraphInfoPtr* output) {
  bool success = true;
  ::webnn::mojom::GraphInfoPtr result(::webnn::mojom::GraphInfo::New());
  
      if (success && !input.ReadIdToOperandMap(&result->id_to_operand_map))
        success = false;
      if (success && !input.ReadInputOperands(&result->input_operands))
        success = false;
      if (success && !input.ReadOutputOperands(&result->output_operands))
        success = false;
      if (success && !input.ReadOperations(&result->operations))
        success = false;
      if (success && !input.ReadConstantIdToBufferMap(&result->constant_id_to_buffer_map))
        success = false;
  *output = std::move(result);
  return success;
}

// static
bool UnionTraits<::webnn::mojom::PaddingMode::DataView, ::webnn::mojom::PaddingModePtr>::Read(
    ::webnn::mojom::PaddingMode::DataView input,
    ::webnn::mojom::PaddingModePtr* output) {
  using UnionType = ::webnn::mojom::PaddingMode;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kConstant: {
      ::webnn::mojom::ConstantPaddingPtr result_constant;
      if (!input.ReadConstant(&result_constant))
        return false;

      *output = UnionType::NewConstant(
          std::move(result_constant));
      break;
    }
    case Tag::kEdge: {
      ::webnn::mojom::EdgePaddingPtr result_edge;
      if (!input.ReadEdge(&result_edge))
        return false;

      *output = UnionType::NewEdge(
          std::move(result_edge));
      break;
    }
    case Tag::kReflection: {
      ::webnn::mojom::ReflectionPaddingPtr result_reflection;
      if (!input.ReadReflection(&result_reflection))
        return false;

      *output = UnionType::NewReflection(
          std::move(result_reflection));
      break;
    }
    case Tag::kSymmetric: {
      ::webnn::mojom::SymmetricPaddingPtr result_symmetric;
      if (!input.ReadSymmetric(&result_symmetric))
        return false;

      *output = UnionType::NewSymmetric(
          std::move(result_symmetric));
      break;
    }
    default:

      return false;
  }
  return true;
}

// static
bool UnionTraits<::webnn::mojom::Activation::DataView, ::webnn::mojom::ActivationPtr>::Read(
    ::webnn::mojom::Activation::DataView input,
    ::webnn::mojom::ActivationPtr* output) {
  using UnionType = ::webnn::mojom::Activation;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kClamp: {
      ::webnn::mojom::ClampPtr result_clamp;
      if (!input.ReadClamp(&result_clamp))
        return false;

      *output = UnionType::NewClamp(
          std::move(result_clamp));
      break;
    }
    case Tag::kElu: {
      ::webnn::mojom::EluPtr result_elu;
      if (!input.ReadElu(&result_elu))
        return false;

      *output = UnionType::NewElu(
          std::move(result_elu));
      break;
    }
    case Tag::kHardSigmoid: {
      ::webnn::mojom::HardSigmoidPtr result_hard_sigmoid;
      if (!input.ReadHardSigmoid(&result_hard_sigmoid))
        return false;

      *output = UnionType::NewHardSigmoid(
          std::move(result_hard_sigmoid));
      break;
    }
    case Tag::kLeakyRelu: {
      ::webnn::mojom::LeakyReluPtr result_leaky_relu;
      if (!input.ReadLeakyRelu(&result_leaky_relu))
        return false;

      *output = UnionType::NewLeakyRelu(
          std::move(result_leaky_relu));
      break;
    }
    case Tag::kLinear: {
      ::webnn::mojom::LinearPtr result_linear;
      if (!input.ReadLinear(&result_linear))
        return false;

      *output = UnionType::NewLinear(
          std::move(result_linear));
      break;
    }
    case Tag::kRelu: {
      ::webnn::mojom::ReluPtr result_relu;
      if (!input.ReadRelu(&result_relu))
        return false;

      *output = UnionType::NewRelu(
          std::move(result_relu));
      break;
    }
    case Tag::kSigmoid: {
      ::webnn::mojom::SigmoidPtr result_sigmoid;
      if (!input.ReadSigmoid(&result_sigmoid))
        return false;

      *output = UnionType::NewSigmoid(
          std::move(result_sigmoid));
      break;
    }
    case Tag::kSoftmax: {
      ::webnn::mojom::SoftmaxPtr result_softmax;
      if (!input.ReadSoftmax(&result_softmax))
        return false;

      *output = UnionType::NewSoftmax(
          std::move(result_softmax));
      break;
    }
    case Tag::kSoftplus: {
      ::webnn::mojom::SoftplusPtr result_softplus;
      if (!input.ReadSoftplus(&result_softplus))
        return false;

      *output = UnionType::NewSoftplus(
          std::move(result_softplus));
      break;
    }
    case Tag::kSoftsign: {
      ::webnn::mojom::SoftsignPtr result_softsign;
      if (!input.ReadSoftsign(&result_softsign))
        return false;

      *output = UnionType::NewSoftsign(
          std::move(result_softsign));
      break;
    }
    case Tag::kTanh: {
      ::webnn::mojom::TanhPtr result_tanh;
      if (!input.ReadTanh(&result_tanh))
        return false;

      *output = UnionType::NewTanh(
          std::move(result_tanh));
      break;
    }
    default:

      return false;
  }
  return true;
}

// static
bool UnionTraits<::webnn::mojom::Operation::DataView, ::webnn::mojom::OperationPtr>::Read(
    ::webnn::mojom::Operation::DataView input,
    ::webnn::mojom::OperationPtr* output) {
  using UnionType = ::webnn::mojom::Operation;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kArgMinMax: {
      ::webnn::mojom::ArgMinMaxPtr result_arg_min_max;
      if (!input.ReadArgMinMax(&result_arg_min_max))
        return false;

      *output = UnionType::NewArgMinMax(
          std::move(result_arg_min_max));
      break;
    }
    case Tag::kBatchNormalization: {
      ::webnn::mojom::BatchNormalizationPtr result_batch_normalization;
      if (!input.ReadBatchNormalization(&result_batch_normalization))
        return false;

      *output = UnionType::NewBatchNormalization(
          std::move(result_batch_normalization));
      break;
    }
    case Tag::kClamp: {
      ::webnn::mojom::ClampPtr result_clamp;
      if (!input.ReadClamp(&result_clamp))
        return false;

      *output = UnionType::NewClamp(
          std::move(result_clamp));
      break;
    }
    case Tag::kConcat: {
      ::webnn::mojom::ConcatPtr result_concat;
      if (!input.ReadConcat(&result_concat))
        return false;

      *output = UnionType::NewConcat(
          std::move(result_concat));
      break;
    }
    case Tag::kConv2d: {
      ::webnn::mojom::Conv2dPtr result_conv2d;
      if (!input.ReadConv2d(&result_conv2d))
        return false;

      *output = UnionType::NewConv2d(
          std::move(result_conv2d));
      break;
    }
    case Tag::kElementWiseBinary: {
      ::webnn::mojom::ElementWiseBinaryPtr result_element_wise_binary;
      if (!input.ReadElementWiseBinary(&result_element_wise_binary))
        return false;

      *output = UnionType::NewElementWiseBinary(
          std::move(result_element_wise_binary));
      break;
    }
    case Tag::kElu: {
      ::webnn::mojom::EluPtr result_elu;
      if (!input.ReadElu(&result_elu))
        return false;

      *output = UnionType::NewElu(
          std::move(result_elu));
      break;
    }
    case Tag::kElementWiseUnary: {
      ::webnn::mojom::ElementWiseUnaryPtr result_element_wise_unary;
      if (!input.ReadElementWiseUnary(&result_element_wise_unary))
        return false;

      *output = UnionType::NewElementWiseUnary(
          std::move(result_element_wise_unary));
      break;
    }
    case Tag::kExpand: {
      ::webnn::mojom::ExpandPtr result_expand;
      if (!input.ReadExpand(&result_expand))
        return false;

      *output = UnionType::NewExpand(
          std::move(result_expand));
      break;
    }
    case Tag::kGather: {
      ::webnn::mojom::GatherPtr result_gather;
      if (!input.ReadGather(&result_gather))
        return false;

      *output = UnionType::NewGather(
          std::move(result_gather));
      break;
    }
    case Tag::kGemm: {
      ::webnn::mojom::GemmPtr result_gemm;
      if (!input.ReadGemm(&result_gemm))
        return false;

      *output = UnionType::NewGemm(
          std::move(result_gemm));
      break;
    }
    case Tag::kHardSigmoid: {
      ::webnn::mojom::HardSigmoidPtr result_hard_sigmoid;
      if (!input.ReadHardSigmoid(&result_hard_sigmoid))
        return false;

      *output = UnionType::NewHardSigmoid(
          std::move(result_hard_sigmoid));
      break;
    }
    case Tag::kLayerNormalization: {
      ::webnn::mojom::LayerNormalizationPtr result_layer_normalization;
      if (!input.ReadLayerNormalization(&result_layer_normalization))
        return false;

      *output = UnionType::NewLayerNormalization(
          std::move(result_layer_normalization));
      break;
    }
    case Tag::kInstanceNormalization: {
      ::webnn::mojom::InstanceNormalizationPtr result_instance_normalization;
      if (!input.ReadInstanceNormalization(&result_instance_normalization))
        return false;

      *output = UnionType::NewInstanceNormalization(
          std::move(result_instance_normalization));
      break;
    }
    case Tag::kLeakyRelu: {
      ::webnn::mojom::LeakyReluPtr result_leaky_relu;
      if (!input.ReadLeakyRelu(&result_leaky_relu))
        return false;

      *output = UnionType::NewLeakyRelu(
          std::move(result_leaky_relu));
      break;
    }
    case Tag::kLinear: {
      ::webnn::mojom::LinearPtr result_linear;
      if (!input.ReadLinear(&result_linear))
        return false;

      *output = UnionType::NewLinear(
          std::move(result_linear));
      break;
    }
    case Tag::kMatmul: {
      ::webnn::mojom::MatmulPtr result_matmul;
      if (!input.ReadMatmul(&result_matmul))
        return false;

      *output = UnionType::NewMatmul(
          std::move(result_matmul));
      break;
    }
    case Tag::kPad: {
      ::webnn::mojom::PadPtr result_pad;
      if (!input.ReadPad(&result_pad))
        return false;

      *output = UnionType::NewPad(
          std::move(result_pad));
      break;
    }
    case Tag::kPool2d: {
      ::webnn::mojom::Pool2dPtr result_pool2d;
      if (!input.ReadPool2d(&result_pool2d))
        return false;

      *output = UnionType::NewPool2d(
          std::move(result_pool2d));
      break;
    }
    case Tag::kPrelu: {
      ::webnn::mojom::PreluPtr result_prelu;
      if (!input.ReadPrelu(&result_prelu))
        return false;

      *output = UnionType::NewPrelu(
          std::move(result_prelu));
      break;
    }
    case Tag::kReduce: {
      ::webnn::mojom::ReducePtr result_reduce;
      if (!input.ReadReduce(&result_reduce))
        return false;

      *output = UnionType::NewReduce(
          std::move(result_reduce));
      break;
    }
    case Tag::kRelu: {
      ::webnn::mojom::ReluPtr result_relu;
      if (!input.ReadRelu(&result_relu))
        return false;

      *output = UnionType::NewRelu(
          std::move(result_relu));
      break;
    }
    case Tag::kResample2d: {
      ::webnn::mojom::Resample2dPtr result_resample2d;
      if (!input.ReadResample2d(&result_resample2d))
        return false;

      *output = UnionType::NewResample2d(
          std::move(result_resample2d));
      break;
    }
    case Tag::kReshape: {
      ::webnn::mojom::ReshapePtr result_reshape;
      if (!input.ReadReshape(&result_reshape))
        return false;

      *output = UnionType::NewReshape(
          std::move(result_reshape));
      break;
    }
    case Tag::kSigmoid: {
      ::webnn::mojom::SigmoidPtr result_sigmoid;
      if (!input.ReadSigmoid(&result_sigmoid))
        return false;

      *output = UnionType::NewSigmoid(
          std::move(result_sigmoid));
      break;
    }
    case Tag::kSlice: {
      ::webnn::mojom::SlicePtr result_slice;
      if (!input.ReadSlice(&result_slice))
        return false;

      *output = UnionType::NewSlice(
          std::move(result_slice));
      break;
    }
    case Tag::kSoftmax: {
      ::webnn::mojom::SoftmaxPtr result_softmax;
      if (!input.ReadSoftmax(&result_softmax))
        return false;

      *output = UnionType::NewSoftmax(
          std::move(result_softmax));
      break;
    }
    case Tag::kSoftplus: {
      ::webnn::mojom::SoftplusPtr result_softplus;
      if (!input.ReadSoftplus(&result_softplus))
        return false;

      *output = UnionType::NewSoftplus(
          std::move(result_softplus));
      break;
    }
    case Tag::kSoftsign: {
      ::webnn::mojom::SoftsignPtr result_softsign;
      if (!input.ReadSoftsign(&result_softsign))
        return false;

      *output = UnionType::NewSoftsign(
          std::move(result_softsign));
      break;
    }
    case Tag::kSplit: {
      ::webnn::mojom::SplitPtr result_split;
      if (!input.ReadSplit(&result_split))
        return false;

      *output = UnionType::NewSplit(
          std::move(result_split));
      break;
    }
    case Tag::kTanh: {
      ::webnn::mojom::TanhPtr result_tanh;
      if (!input.ReadTanh(&result_tanh))
        return false;

      *output = UnionType::NewTanh(
          std::move(result_tanh));
      break;
    }
    case Tag::kTranspose: {
      ::webnn::mojom::TransposePtr result_transpose;
      if (!input.ReadTranspose(&result_transpose))
        return false;

      *output = UnionType::NewTranspose(
          std::move(result_transpose));
      break;
    }
    case Tag::kWhere: {
      ::webnn::mojom::WherePtr result_where;
      if (!input.ReadWhere(&result_where))
        return false;

      *output = UnionType::NewWhere(
          std::move(result_where));
      break;
    }
    default:

      return false;
  }
  return true;
}

// static
bool UnionTraits<::webnn::mojom::ComputeResult::DataView, ::webnn::mojom::ComputeResultPtr>::Read(
    ::webnn::mojom::ComputeResult::DataView input,
    ::webnn::mojom::ComputeResultPtr* output) {
  using UnionType = ::webnn::mojom::ComputeResult;
  using Tag = UnionType::Tag;

  switch (input.tag()) {
    case Tag::kNamedOutputs: {
      base::flat_map<std::string, ::mojo_base::BigBuffer> result_named_outputs;
      if (!input.ReadNamedOutputs(&result_named_outputs))
        return false;

      *output = UnionType::NewNamedOutputs(
          std::move(result_named_outputs));
      break;
    }
    case Tag::kError: {
      ::webnn::mojom::ErrorPtr result_error;
      if (!input.ReadError(&result_error))
        return false;

      *output = UnionType::NewError(
          std::move(result_error));
      break;
    }
    default:

      return false;
  }
  return true;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace webnn::mojom {


void WebNNGraphInterceptorForTesting::Compute(base::flat_map<std::string, ::mojo_base::BigBuffer> named_inputs, ComputeCallback callback) {
  GetForwardingInterface()->Compute(std::move(named_inputs), std::move(callback));
}
WebNNGraphAsyncWaiter::WebNNGraphAsyncWaiter(
    WebNNGraph* proxy) : proxy_(proxy) {}

WebNNGraphAsyncWaiter::~WebNNGraphAsyncWaiter() = default;

void WebNNGraphAsyncWaiter::Compute(
    base::flat_map<std::string, ::mojo_base::BigBuffer> named_inputs, ComputeResultPtr* out_result) {
  base::RunLoop loop;
  proxy_->Compute(std::move(named_inputs),
      base::BindOnce(
          [](base::RunLoop* loop,
             ComputeResultPtr* out_result
,
             ComputeResultPtr result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}

ComputeResultPtr WebNNGraphAsyncWaiter::Compute(
    base::flat_map<std::string, ::mojo_base::BigBuffer> named_inputs) {
  ComputeResultPtr async_wait_result;
  Compute(std::move(named_inputs),&async_wait_result);
  return async_wait_result;
}






}  // webnn::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif